set terminal postscript eps color
set xlabel "Message size (kb)"
set ylabel "Execution time (sec)"
set key below

set output "scatter.eps"
plot\
	"scatter.out" using ($1/1024):2:5 title "observation" with errorlines 0,\
	"lmo.out" using ($1/1024):2 index 1 title "LMO prediction" with lines 1,\
	"hockney.out" using ($1/1024):2 index 1 title "Hockney prediction" with lines 2

set output "gather.eps"
plot\
	"gather.out" using ($1/1024):2:5 title "observation" with errorlines 0,\
	"lmo.out" using ($1/1024):2 index 2 title "LMO prediction" with lines 1,\
	"hockney.out" using ($1/1024):2 index 1 title "Hockney prediction" with lines 2

set output "p2p.eps"
plot\
	"p2p.out" using ($1/1024):2:5 title "observation" with errorlines 0,\
	"lmo.out" using ($1/1024):2 index 0 title "LMO prediction" with lines 1,\
	"hockney.out" using ($1/1024):2 index 0 title "Hockney prediction" with lines 2,\
	"plogp.out" using ($1/1024):2 index 0 title "PLogP prediction" with lines 3,\
	"" using ($1/1024):2 index 1 title "LogGP prediction" with lines 4
