#include "cpm.h"
#include <stdio.h>
#include <getopt.h>
#include <string.h>

void CPM_getopt_coll_optarg(int c, char* operation, char* timing)
{
	switch (c)
	{
		case 'h':
			fprintf
			(
				stderr,
"-O S			collective operation (required):\n\
			MPI_Scatter, MPIB_Scatter_linear, MPIB_Scatter_binomial\n\
			MPI_Gather, MPIB_Gather_linear, MPIB_Gather_binomial\n\
			MPI_Scatterv\n\
			MPI_Gatherv\n\
			CPM_Scatter_linear_opt\n\
			CPM_Gather_linear_opt\n\
			CPM_Scatter_binomial_opt, CPM_Scatter_binomial_cor\n\
			CPM_Gather_binomial_opt, CPM_Gather_binomial_cor\n\
-t S			timing: max, root, global (default: %s)\n",
				timing
			);
			break;
		case 'O':
			strcpy(operation, optarg);
			break;
		case 't':
			strcpy(timing, optarg);
			break;
	}
}

void CPM_getopt_coll_bcast(char* operation, MPIB_coll_container** container,
	char* timing, MPIB_measure_coll* measure, int root, MPI_Comm comm)
{
	MPIB_getopt_coll_bcast(operation, container, timing, measure, root, comm);
	if (*container == NULL)
	{
		if (!strcmp(operation, "CPM_Scatter_linear_opt")) 
			*container = MPIB_Scatter_container_alloc(CPM_Scatter_linear_opt);
		if (!strcmp(operation, "CPM_Gather_linear_opt"))
			*container = MPIB_Gather_container_alloc(CPM_Gather_linear_opt);
		if (!strcmp(operation, "CPM_Scatter_binomial_opt"))
			*container = MPIB_Scatter_container_alloc(CPM_Scatter_binomial_opt);
		if (!strcmp(operation, "CPM_Scatter_binomial_cor"))
			*container = MPIB_Scatter_container_alloc(CPM_Scatter_binomial_cor);
		if (!strcmp(operation, "CPM_Gather_binomial_opt"))
			*container = MPIB_Gather_container_alloc(CPM_Gather_binomial_opt);
		if (!strcmp(operation, "CPM_Gather_binomial_cor"))
			*container = MPIB_Gather_container_alloc(CPM_Gather_binomial_cor);
	}
}
